import java.util.ArrayList;
import java.util.List;

public class GebietsListe implements GebietsListeInterface{
    private List<Gebiet> gebiete = new ArrayList<>();

    public GebietsListe(List<Gebiet> gebiete) {
        this.gebiete = gebiete;
    }

    public Gebiet getGebietMinDurchschnittsEinkommen() {
        return gebiete.stream()
                .filter(g -> g.getDurchschnittsEinkommen() != -1)
                .min((g1, g2) -> g1.getDurchschnittsEinkommen() - g2.getDurchschnittsEinkommen())
                .get();
    }

    public Gebiet getGebietMaxAnzahlEinwohner() {
        return gebiete.stream()
                .filter(g -> g.getDurchschnittsEinkommen() != -1)
                .max((g1, g2) -> g1.getAnzahlEinwohner() - g2.getAnzahlEinwohner())
                .get();
    }

    public int getAnzahlGesamt() {
        return gebiete.size();
    }

    public int getAnzahlUnvollständig() {
        return (int) gebiete.stream()
                .filter(g -> g.getDurchschnittsEinkommen() == -1 || g.getGesamtEinkommen() == -1)
                .count();
    }

    public List<Gebiet> getGebieteNachNamen(String namensanfang) {
        return gebiete.stream()
                .filter(g -> g.getName().startsWith(namensanfang))
                .toList();
    }
}
